import numpy
import random
import emcee
from math import exp, log, sqrt
import matplotlib.pyplot as plt

random.seed(1234)
numpy.random.seed(5678)

dim = 5
sg = 0.01
n = 3
v = [numpy.zeros(dim) for i in range(2**n)]
for i, vi in enumerate(v):
    for j in range(n):
        vi[j] = (-1.0)**(i // 2**j)

def dsq(x,y):
    d = y-x
    return numpy.dot(d,d)


def lnprob(x):
    d = [x - vi for vi in v]
    p = dim + 2
    try:
        return log(sum(sg**p/(sg**p + numpy.dot(di,di)**(0.5*p)) 
                       for di in d))
    except ValueError:
        return -numpy.inf

def lnlike(x):
    return 0.0

ntemps = 5
nwalkers = 300

p0 = numpy.random.normal(0.0, 2.0, size=(ntemps, nwalkers, dim))
betas = numpy.array([0.5**n for n in range(ntemps)])
sampler=emcee.PTSampler(ntemps, nwalkers, dim, lnprob, lnlike)

p = p0
for i in range(50):
    for p, lnprob, lnlike in sampler.sample(p, iterations=10):
        pass
    print numpy.sum(sampler.acceptance_fraction[0])/nwalkers
    sampler.reset()

for vi in v:
    print sum(1 if dsq(vi, xi) <= 1.0 else 0 for xi in p[0])

# for p, lnprob, lnlike in sampler.sample(p, lnprob0=lnprob,
#                                            lnlike0=lnlike,
#                                            iterations=1000, thin=1):
#     pass
